import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { ChartModule } from 'angular-highcharts';
import { AppRoutingModule } from './app-routing.module';
import { HttpModule } from '@angular/http';
import { HttpClientModule } from '@angular/common/http';
import { environment } from '../environments/environment';

import highmaps from 'highcharts/modules/map.src';


import { AppComponent } from './app.component';
import { FooterComponent } from './footer/footer.component';
import { HeaderComponent } from './header/header.component';
import { MainPageComponent } from './main-page/main-page.component';
import { AboutComponent } from './about/about.component';
import { MapsPageComponent } from './maps-page/maps-page.component';
import { HospitalSelectorComponent } from './hospital-selector/hospital-selector.component';
import { GraphsPageComponent } from './graphs-page/graphs-page.component';
import { GraphElementComponent } from './graphs-page/graph-element/graph-element.component';

import { DataApiService } from './data-api.service';
import { ReportService, MockReportService, WebserviceReportService } from './report.service';


@NgModule({
  declarations: [
    AppComponent,
    FooterComponent,
    MainPageComponent,
    HeaderComponent,
    AboutComponent,
    GraphsPageComponent,
    GraphElementComponent,
    MapsPageComponent,
    HospitalSelectorComponent,
    GraphsPageComponent,
    GraphElementComponent
  ],
  imports: [
    BrowserModule,
    BrowserAnimationsModule,
    AppRoutingModule,
    FormsModule,
    ChartModule,
    HttpClientModule,
    HttpModule
  ],
  providers: [
    DataApiService,
    { provide: 'ReportService', useClass: environment.reportServiceType }
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
