import { Injectable } from '@angular/core';
import * as $ from 'jquery';

declare var da: any;



@Injectable()
export class DataApiService {
    private domainBackEnd = "http://pinsisdev.c3sl.ufpr.br:3000"
    
    //Agent
    public getAgentById(id,agents){
        var hospital = null;
        for(var i in agents){
            if(parseInt(agents[i].id) == parseInt(id)){
                hospital = agents[i];
            }
        }
        return hospital;
    }
    
    public loadAgents(callback, countie = null){
        var url = this.domainBackEnd+"/api/data/listAgents";
        if(countie)
            url+="?countie="+countie;
        $.getJSON(url, function(result){
            callback(result);
        });
    }
    //
    
    
    //Uses
    
    
    
    /*
    config format:
    {
        "type": string 
        "y1": int, "y2": int, "m1": int,
        "m2": int, "d1": int, "d2": int
    }
    type field must be 'day' or 'month' and its default value is 'day'
    
    
    1 and 2 represents the intervale between dates (from 1 to 2)
    d = day; m = month; y = year;
    
    To use day, its necessary set month, and to use month its
    necessary to use year
    If this fields are invalid or omited, all entries will be returned
    */
    
    public loadData(callback, config){
        var type = "agentusesday";

        if(config.type == "month") type = "agentusesmonth";
        $.getJSON(this.domainBackEnd+"/api/data/"+type, config, function(result){
            callback(result);
        });
    }
    //
    
    
    
    //Geolocation
    private cacheStates = null;
    public loadStates(callback){
        var da = this;
        
        if(da.cacheStates != null){
            callback(this.cacheStates);
            return;
        }
        
        $.getJSON(this.domainBackEnd+"/geolocation/states.json", function(result){
            var features = [];
            for(var i in result.states){
                for(var j in result.states[i].features){
                    features.push(result.states[i].features[j]);
                }
            }
            da.cacheStates = features;
            callback(features);
        });
    }
    
    public selectCountiesFromState(state, callback){
        $.getJSON(this.domainBackEnd+"/geolocation/"+state+"-cities.json",function(result){
            var features = [];
            for(var i in result.cities){
                for(var j in result.cities[i].features){
                    features.push(result.cities[i].features[j]);
                }
            }
            callback(features);
        });
    }
    
    public selectStateFeature(state, callback){
        $.getJSON(this.domainBackEnd+"/geolocation/"+state+".json",function(x){
            callback(x);
        });
    }
    //
  

    constructor() { }

}
